diff -urX /home/leigh/.diffex linuxppc_2_4_devel/arch/ppc/kernel/Makefile linuxppc_2_4_devel-140/arch/ppc/kernel/Makefile
--- linuxppc_2_4_devel/arch/ppc/kernel/Makefile	Mon Nov 26 17:10:41 2001
+++ linuxppc_2_4_devel-140/arch/ppc/kernel/Makefile	Mon Nov 26 22:27:56 2001
@@ -61,7 +61,7 @@
 obj-$(CONFIG_PPLUS)		+= pplus_common.o open_pic.o i8259.o \
 				   indirect_pci.o todc_time.o pci_auto.o
 obj-$(CONFIG_ALL_PPC)		+= prom.o open_pic.o indirect_pci.o i8259.o
-obj-$(CONFIG_PREP_RESIDUAL)	+= residual.o
+obj-$(CONFIG_PREP_RESIDUAL)	+= residual.o pci_auto.o
 obj-$(CONFIG_PPC_RTAS)		+= error_log.o proc_rtas.o
 obj-$(CONFIG_ADIR)		+= i8259.o indirect_pci.o pci_auto.o \
 					todc_time.o
diff -urX /home/leigh/.diffex linuxppc_2_4_devel/arch/ppc/platforms/prep_pci.c linuxppc_2_4_devel-140/arch/ppc/platforms/prep_pci.c
--- linuxppc_2_4_devel/arch/ppc/platforms/prep_pci.c	Mon Nov 26 17:11:40 2001
+++ linuxppc_2_4_devel-140/arch/ppc/platforms/prep_pci.c	Mon Nov 26 22:27:56 2001
@@ -1126,6 +1126,7 @@
 	prep_route_pci_interrupts();
 
 	printk("Setting PCI interrupts for a \"%s\"\n", Motherboard_map_name);
+
 	if (OpenPIC_Addr) {
 		/* PCI interrupts are controlled by the OpenPIC */
 		pci_for_each_dev(dev) {
@@ -1211,13 +1212,20 @@
 
 	hose->first_busno = 0;
 	hose->last_busno = 0xff;
+
 	hose->pci_mem_offset = PREP_ISA_MEM_BASE;
-	hose->io_base_phys = PREP_ISA_IO_BASE;
-	hose->io_base_virt = (void *)0x80000000; /* see prep_map_io() */
+/*	hose->io_base_phys   = PREP_ISA_IO_BASE; */
+	hose->io_base_virt   = (void *)PREP_ISA_IO_BASE;
+
 	prep_init_resource(&hose->io_resource, 0, 0x0fffffff, IORESOURCE_IO);
 	prep_init_resource(&hose->mem_resources[0], 0xc0000000, 0xfeffffff,
 			   IORESOURCE_MEM);
 	
+	hose->io_space.start  = 0x00000000;
+	hose->io_space.end    = 0x0fffffff;
+	hose->mem_space.start = 0x00000000;
+	hose->mem_space.end   = 0x3effffff;
+
 	printk("PReP architecture\n");
 	{
 #ifdef CONFIG_PREP_RESIDUAL	  
@@ -1242,6 +1250,8 @@
 #endif /* CONFIG_PREP_RESIDUAL */
 			hose->ops = &prep_pci_ops;
 	}
+
+	hose->last_busno = pciauto_bus_scan(hose, hose->first_busno);
 
 	ppc_md.pcibios_fixup = prep_pcibios_fixup;
 }
